<template>
  <div>
    <div class="q-ma-md">
      <q-btn color="black" text-color="white" label="Y/N/A" @click="setYNA()" />
    </div>
    <div>
      <q-input class="q-ml-md" v-model="quest" label="Question" />
    </div>
    <div>
      <q-input class="q-ml-md" v-model="desc" label="Short description" />
    </div>
    <div v-for="(line, index) in lines" :key="index" class="row">
      <div>
        <div class="row">
          <div class="col-lg-10">
            <q-input
              class="q-ml-md"
              v-model="line.text"
              label="Option"
              value=""
            />
          </div>
        </div>
      </div>
      <div>
        <div class="block float-right">
          <q-btn round @click="removeLine(index)" icon="delete" />
          <q-btn
            round
            v-if="index + 1 === lines.length"
            @click="addLine"
            icon="add"
          />
        </div>
      </div>
    </div>
    <div>
      <q-radio v-model="maj" val="simple" label="Simple majority" />
      <q-radio v-model="maj" val="absolute" label="Absolute majority" />
    </div>
    <div class="column">
      <div class="row">
        <q-radio
          v-model="lvl"
          val="public"
          label="Public"
          @input="checkAccessLvl"
        />
        <q-select
          class="q-ml-lg"
          v-model="req_rank"
          :options="[1, 2, 3]"
          :disable="publicCheck"
          label="Access Level"
          @click="checkAccessLvl"
        />
      </div>
      <q-radio
        v-model="lvl"
        val="board"
        label="Company Board"
        @input="checkAccessLvl"
      />
      <div class="row">
        <q-radio
          v-model="lvl"
          val="department"
          label="Department"
          @input="checkAccessLvl"
        />

        <q-select
          class="q-ml-lg"
          v-model="dep"
          :options="departments"
          :disable="depCheck"
          label="Department"
          @click="checkAccessLvl"
        />
      </div>
    </div>
    <div class="row">
      <q-input label="Open date" filled v-model="openDateString">
        <template v-slot:prepend>
          <q-icon name="event" class="cursor-pointer">
            <q-popup-proxy transition-show="scale" transition-hide="scale">
              <q-date v-model="openDateString" mask="DD MMM YYYY HH:mm">
                <div class="row items-center justify-end">
                  <q-btn v-close-popup label="Close" color="primary" flat />
                </div>
              </q-date>
            </q-popup-proxy>
          </q-icon>
        </template>

        <template v-slot:append>
          <q-icon name="access_time" class="cursor-pointer">
            <q-popup-proxy transition-show="scale" transition-hide="scale">
              <q-time
                v-model="openDateString"
                mask="DD MMM YYYY HH:mm"
                format24h
              >
                <div class="row items-center justify-end">
                  <q-btn v-close-popup label="Close" color="primary" flat />
                </div>
              </q-time>
            </q-popup-proxy>
          </q-icon>
        </template>
      </q-input>

      <q-input label="Close date" filled v-model="closeDateString">
        <template v-slot:prepend>
          <q-icon name="event" class="cursor-pointer">
            <q-popup-proxy transition-show="scale" transition-hide="scale">
              <q-date v-model="closeDateString" mask="DD MMM YYYY HH:mm">
                <div class="row items-center justify-end">
                  <q-btn v-close-popup label="Close" color="primary" flat />
                </div>
              </q-date>
            </q-popup-proxy>
          </q-icon>
        </template>

        <template v-slot:append>
          <q-icon name="access_time" class="cursor-pointer">
            <q-popup-proxy transition-show="scale" transition-hide="scale">
              <q-time
                v-model="closeDateString"
                mask="DD MMM YYYY HH:mm"
                format24h
              >
                <div class="row items-center justify-end">
                  <q-btn v-close-popup label="Close" color="primary" flat />
                </div>
              </q-time>
            </q-popup-proxy>
          </q-icon>
        </template>
      </q-input>
    </div>
    <q-btn
      class="q-ma-md"
      color="dark"
      icon="add_box"
      label="Create Poll"
      @click="submit"
    />
  </div>
</template>

<script>
import { api } from "boot/axios";

export default {
  data() {
    return {
      lines: [],
      blockRemoval: true,
      quest: "",
      desc: "",
      maj: "simple",
      lvl: "public",
      dep: null,
      req_rank: null,
      departments: [],
      depCheck: true,
      publicCheck: true,
      currentDate: new Date(),
      openDateString: new Date().toLocaleString(),
      closeDateString: new Date().toLocaleString(),
      optionsArray: []
    };
  },
  watch: {
    lines() {
      this.blockRemoval = this.lines.length <= 1;
    }
  },
  methods: {
    addLine() {
      let checkEmptyLines = this.lines.filter(line => line.text === null);

      if (checkEmptyLines.length >= 1 && this.lines.length > 0) {
        return;
      }

      this.lines.push({
        text: null
      });
    },

    setYNA() {
      // console.log(this.dep);
      this.lines = [{ text: "YES" }, { text: "NO" }, { text: "Abstain" }];
    },

    removeLine(lineId) {
      if (!this.blockRemoval) {
        this.lines.splice(lineId, 1);
      }
    },

    checkIfDep() {
      if (this.lvl === "department") this.depCheck = false;
      else this.depCheck = true;
    },

    checkIfPublic() {
      if (this.lvl === "public") this.publicCheck = false;
      else this.publicCheck = true;
    },

    checkAccessLvl() {
      this.checkIfDep();
      this.checkIfPublic();
    },

    convertDateToUTC(date) {
      return new Date(
        date.getUTCFullYear(),
        date.getUTCMonth(),
        date.getUTCDate(),
        date.getUTCHours(),
        date.getUTCMinutes()
      );
    },

    submit() {
      this.optionsArray.splice(0);
      this.lines.forEach(element => {
        this.optionsArray.push(element.text);
      });

      var openDateString = this.openDateString; //+ " " + new Date().getTimezoneOffset();
      var closeDateString = this.closeDateString; //+ " " + new Date().getTimezoneOffset();

      console.log(openDateString);
      console.log(closeDateString);

      var openDate = new Date();
      var closeDate = new Date();

      openDate = Date.parse(openDateString);
      closeDate = Date.parse(closeDateString);

      const openDateFinal = new Date(openDate);
      const closeDateFinal = new Date(closeDate);

      console.log(openDate);
      console.log(closeDate);

      const url = window.location.pathname;
      const tkn = url.substring(url.lastIndexOf("/") + 1);

      var pollData = {
        question: this.quest,
        description: this.desc,
        majority: this.maj,
        access_lvl: this.lvl == "department" ? this.dep : this.lvl,
        required_rank: this.req_rank,
        open_date: openDateFinal.toUTCString(),
        close_date: closeDateFinal.toUTCString(),
        options: this.optionsArray
      };

      if (pollData.access_lvl == "public")
        pollData.required_rank = this.req_rank;

      if (pollData.access_lvl == "board") pollData.required_rank = 3;

      if (pollData.access_lvl != "public" && pollData.access_lvl != "board")
        pollData.required_rank = 1;

      console.log(pollData);

      api
        .post("/api/poll/editPoll", {
          polltkn: tkn,
          data: pollData,
          token: window.sessionStorage.getItem("token")
        })
        .then(res => {
          if (res.status === 200) {
            this.$q.notify({
              color: "secondary",
              textColor: "white",
              icon: "check",
              message: `Poll updated! Token: ${res.data.poll_tkn}`
            });

            setTimeout(() => {
              this.$router.push("/admin");
            }, 5000);
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },
    getDepartments() {
      api.post("/api/user/getDepartments").then(res => {
        // console.log(res.data);
        for (let i = 0; i < res.data.departments.length; i++)
          this.departments.unshift(res.data.departments[i].dep_code);
      });
    },
    getPoll() {
      console.log("getPoll");
      const url = window.location.pathname;
      const tkn = url.substring(url.lastIndexOf("/") + 1);

      const reqData = {
        tkn: tkn
      };

      console.log(reqData);

      api
        .post("/api/poll/getpoll", reqData)
        .then(res => {
          console.log(res.data);
          this.quest = res.data.poll.question;
          this.desc = res.data.poll.desc;
          this.maj = res.data.poll.majority;
          // this.lvl = res.data.poll.access_lvl;
          this.openDateString = res.data.poll.open_date;
          this.closeDateString = res.data.poll.close_date;
          this.optionsArray = res.data.options;

          this.req_rank = res.data.poll.required_rank;

          if (
            res.data.poll.access_lvl != "public" &&
            res.data.poll.access_lvl != "board"
          ) {
            this.lvl = "department";
            this.dep = res.data.poll.access_lvl;
          }

          this.lines = [];
          for (let i = 0; i < this.optionsArray.length; i++) {
            this.addLine();
            this.lines[i].text = this.optionsArray[i].text;
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    }
  },

  mounted() {
    this.addLine();
    this.getPoll();
    this.checkAccessLvl();
    this.getDepartments();
  }
};
</script>

<style scoped>
.q-select {
  width: 200px;
}
</style>
